UNIT Divers;

INTERFACE

VAR
  Code : INTEGER;

  FUNCTION  Maj(Mot2 : STRING) : STRING; {Transforme une chaine en majuscules}
  FUNCTION  Choix(Cars : STRING) : CHAR;    {Menu. Ex:'ON' choix entre O et N}
  FUNCTION  Valeur(Chaine : STRING) : LONGINT;               {Val en fonction}
  FUNCTION  Chaine(Nombre : LONGINT) : STRING;               {Str en fonction}
  FUNCTION  Hexa(Nombre : LONGINT) : STRING;           {Dcimal-->Hexidcimal}
  FUNCTION  Deci(Chaine : STRING) : LONGINT;           {Hexadcimal-->Dcimal}
  PROCEDURE Curseur(plc, dlc : BYTE);               {Apparence du curseur Dos}
  PROCEDURE SimpleCadre(x1, y1, x2, y2 : BYTE);        {Trace un cadre simple}
  PROCEDURE DoubleCadre(x1, y1, x2, y2 : BYTE);        {Trace un cadre double}
  PROCEDURE Efface(x1, y1, x2, y2, couleur : INTEGER); {Eff 1 fen d'1 couleur}
  PROCEDURE Color(Texte, Fond : INTEGER);           {TextColor+TextBackGround}
  PROCEDURE Sauve_ecran;                              {Met l'cran en mmoire}
  PROCEDURE Restaure_ecran;                   {Affiche l'cran mis en mmoire}
  PROCEDURE Lit(VAR Chaine : STRING);      {Lit une chaine (=ReadLn amlior)}

IMPLEMENTATION

  USES
    Crt, Dos;

  FUNCTION Maj(mot2 : STRING) : STRING;
    VAR
      i : BYTE;
    BEGIN
      FOR i := 1 TO Length(mot2) DO mot2[i] := UpCase(mot2[i]);
      maj := mot2
    END;

  FUNCTION Choix(Cars : STRING) : CHAR;
    VAR
      i      : BYTE;
      k      : CHAR;
      Choisi : BOOLEAN;
    BEGIN
      Choisi := False;
      Cars := Maj(Cars);
      REPEAT
        k := ReadKey;
        FOR i := 1 TO Length(Cars) DO
	    IF UpCase(k)=Copy(Cars,i,1) THEN Choisi := True
      UNTIL Choisi=True;
      Choix := UpCase(k)
    END;

  FUNCTION Valeur(Chaine : STRING) : LONGINT;
    VAR
      a : LONGINT;
    BEGIN
      Val(Chaine,a,Code);
      Valeur:=a
    END;

  FUNCTION Chaine(Nombre : LONGINT) : STRING;
    VAR
      a : STRING;
    BEGIN
      Str(Nombre,a);
      Chaine:=a
    END;

  FUNCTION Hexa(Nombre : LONGINT) : STRING;
    CONST a : ARRAY[0..15] OF STRING[1]=
    ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
    VAR
      b : STRING;
      c : LONGINT;
    BEGIN
      b:='';
      REPEAT
        c:=Nombre mod 16;
        Nombre:=Nombre div 16;
        Insert(a[c],b,1)
      UNTIL Nombre=0;
      Hexa:=b
    END;

  FUNCTION Deci(Chaine : STRING) : LONGINT;
    VAR
      i : BYTE;
      b : LONGINT;
    FUNCTION Puiss(nbr,pui : INTEGER) : LONGINT;
      VAR
        Resultat : LONGINT;
        j        : BYTE;
      BEGIN
        Resultat:=1; Puiss:=1; IF pui=0 THEN Exit;
        FOR j:=1 TO pui DO Resultat:=Resultat*nbr;
        IF Resultat<0 THEN BEGIN WriteLn('Resultat<0:',Resultat); Halt END;
        Puiss:=Resultat
      END;
    FUNCTION Transcrit(Str : STRING) : INTEGER;
      VAR
        a : BYTE;
      BEGIN
        IF (Str>='0') AND (Str<='9') THEN a:=Valeur(Str)
        ELSE
          BEGIN
            Str:=Maj(Str);
            IF Str='A' THEN a:=10
            ELSE IF Str='B' THEN a:=11
            ELSE IF Str='C' THEN a:=12
            ELSE IF Str='D' THEN a:=13
            ELSE IF Str='E' THEN a:=14
            ELSE IF Str='F' THEN a:=15
            ELSE a:=0
          END;
        Transcrit:=a
      END;
    BEGIN  { de Deci }
      b:=0;
      FOR i:=Length(Chaine) DOWNTO 1 DO
        b:=b+(Transcrit(Copy(Chaine,i,1))*Puiss(16,Length(Chaine)-i));
      Deci:=b
    END;

  PROCEDURE Curseur(plc, dlc : BYTE);
    VAR
      Regs : REGISTERS;
    BEGIN
      Regs.AH := $01;
      Regs.CH := Plc;
      Regs.CL := Dlc;
      Intr($10, Regs)
    END;

  PROCEDURE SimpleCadre(x1, y1, x2, y2 : BYTE);
    VAR
      i : BYTE;
    BEGIN
      GotoXY(x1,y1); Write('');
      GotoXY(x2,y1); Write('');
      GotoXY(x1,y2); Write('');
      GotoXY(x2,y2); Write('');
      FOR i := x1+1 TO x2-1 DO
        BEGIN
          GotoXY(i,y1); Write('');
          GotoXY(i,y2); Write('')
        END;
      FOR i := y1+1 TO y2-1 DO
        BEGIN
          GotoXY(x1,i); Write('');
          GotoXY(x2,i); Write('')
        END
    END;

  PROCEDURE DoubleCadre(x1, y1, x2, y2 : BYTE);
    VAR
     i : BYTE;
    BEGIN
      GotoXY(x1, y1); Write('');
      GotoXY(x2, y1); Write('');
      GotoXY(x1, y2); Write('');
      GotoXY(x2, y2); Write('');
      FOR i := x1+1 TO x2-1 DO
        BEGIN
          GotoXY(i, y1); Write('');
          GotoXY(i, y2); Write('')
        END;
      FOR i := y1+1 TO y2-1 DO
        BEGIN
          GotoXY(x1, i); Write('');
          GotoXY(x2, i); Write('')
        END
    END;

  PROCEDURE Efface(x1, y1, x2, y2, couleur : INTEGER);
    VAR
      a,x,y : INTEGER;
    BEGIN
      a:=TextAttr;
      x:=Lo(WindMax)+1; y:=Hi(WindMax)+1;
      TextBackGround(couleur);
      Window(x1, y1, x2, y2);
      ClrScr;
      Window(1, 1, x, y);
      TextAttr:=a
    END;

  PROCEDURE Color(Texte, Fond : INTEGER);
    BEGIN
      TextColor(Texte);
      TextBackGround(Fond)
    END;

  VAR
    Ecran : ARRAY[1..4096] OF BYTE;
    xc,yc : INTEGER;

  PROCEDURE Sauve_ecran;
    BEGIN
      xc:=WhereX; yc:=WhereY;
      Move(Mem[$B800:0000],Ecran,4096)
    END;

  PROCEDURE Restaure_ecran;
    BEGIN
      Move(Ecran,Mem[$B800:0000],4096);
      GotoXY(xc,yc)
    END;

  PROCEDURE Lit(VAR Chaine : STRING);
    VAR
      x,y : BYTE;        { corrdonnes du curseur  l'appel de Lit }
      xx  : BYTE;        { position actuelle du curseur dans la chaine }
      k   : CHAR;        { caractre tap au clavier }
      ch  : STRING[80];  { chaine en cours d'dition }
      a   : STRING[1];
    BEGIN
      x:=WhereX; y:=WhereY; ch:=''; xx:=x;
      REPEAT
        GotoXY(xx,y);
        k:=ReadKey;
        IF k=#0 THEN
          BEGIN
            k:=ReadKey;
            CASE k OF
              'H','G','I':xx:=x;
              'P','O','Q':xx:=x+Length(ch);
              'K':IF xx>x THEN xx:=xx-1;
              'M':IF xx-x<Length(ch) THEN xx:=xx+1;
              'S':IF Length(ch)>0 THEN
                    BEGIN Delete(ch,xx-x+1,1); GotoXY(x,y); Write(ch,' ') END
            END
          END
        ELSE
          BEGIN
            CASE k OF
              #8:IF xx>x THEN
                   BEGIN
                     Delete(ch,xx-x,1);
                     xx:=xx-1;
                     GotoXY(x,y); Write(ch,' ')
                   END;
              #32..#125:IF xx<80 THEN
                          BEGIN
                            a:=k;
                            Insert(a,ch,xx-x+1);
                            GotoXY(xx,y);
                            Write(Copy(ch,xx-x+1,Length(ch)-xx+x));
                            xx:=xx+1
                          END
            END
          END
      UNTIL (k=#13) OR (k=#27);
      IF k=#13 THEN Chaine:=ch ELSE Chaine:=''
    END;
END.